set "opnfv-lint-verify" as the basic verify of compass
[releng.git] / jjb / opnfv / opnfv-docker.sh
index bf35597..e637f7b 100644 (file)
@@ -1,4 +1,12 @@
 #!/bin/bash
+# SPDX-license-identifier: Apache-2.0
+##############################################################################
+# Copyright (c) 2016 Ericsson AB and others.
+# All rights reserved. This program and the accompanying materials
+# are made available under the terms of the Apache License, Version 2.0
+# which accompanies this distribution, and is available at
+# http://www.apache.org/licenses/LICENSE-2.0
+##############################################################################
 set -o errexit
 set -o nounset
 set -o pipefail
@@ -9,6 +17,14 @@ echo "--------------------------------------------------------"
 echo
 
 
+if [[ -n $(ps -ef|grep 'docker build'|grep -v grep) ]]; then
+    echo "There is already another build process in progress:"
+    echo $(ps -ef|grep 'docker build'|grep -v grep)
+    # Abort this job since it will colide and might mess up the current one.
+    echo "Aborting..."
+    exit 1
+fi
+
 # Remove previous running containers if exist
 if [[ -n "$(docker ps -a | grep $DOCKER_REPO_NAME)" ]]; then
     echo "Removing existing $DOCKER_REPO_NAME containers..."
@@ -43,7 +59,7 @@ if [[ "$UPDATE_LATEST_STABLE" == "true" ]]; then
         echo "ERROR: The image $DOCKER_REPO_NAME with tag $STABLE_TAG does not exist."
         exit 1
     fi
-    docker tag -f $DOCKER_REPO_NAME:$STABLE_TAG $DOCKER_REPO_NAME:latest_stable
+    docker tag $DOCKER_REPO_NAME:$STABLE_TAG $DOCKER_REPO_NAME:latest_stable
     echo "Pushing $DOCKER_REPO_NAME:latest_stable ..."
     docker push $DOCKER_REPO_NAME:latest_stable
     exit 0
@@ -51,16 +67,9 @@ fi
 
 
 # cd to directory where Dockerfile is located
-if [[ "$DOCKER_REPO_NAME" == "opnfv/functest" ]]; then
-    cd $WORKSPACE/docker
-elif [[ "$DOCKER_REPO_NAME" == "opnfv/yardstick" ]]; then
-    cd $WORKSPACE/ci/docker/yardstick-ci
-elif [[ "$DOCKER_REPO_NAME" == "opnfv/storperf" ]]; then
-    cd $WORKSPACE/docker
-elif [[ "$DOCKER_REPO_NAME" == "opnfv/qtip" ]]; then
-    cd $WORKSPACE/docker
-else
-    echo "ERROR: DOCKER_REPO_NAME parameter not valid: $DOCKER_REPO_NAME"
+cd $WORKSPACE/docker
+if [ ! -f ./Dockerfile ]; then
+    echo "ERROR: Dockerfile not found."
     exit 1
 fi
 
@@ -70,11 +79,13 @@ echo "Current branch: $branch"
 
 if [[ "$branch" == "master" ]]; then
     DOCKER_TAG="master"
+    DOCKER_BRANCH_TAG="latest"
 else
     git clone https://gerrit.opnfv.org/gerrit/releng $WORKSPACE/releng
 
     DOCKER_TAG=$($WORKSPACE/releng/utils/calculate_version.sh -t docker \
         -n $DOCKER_REPO_NAME)
+    DOCKER_BRANCH_TAG="stable"
 
     ret_val=$?
     if [[ $ret_val -ne 0 ]]; then
@@ -86,11 +97,16 @@ echo "Tag version to be build and pushed: $DOCKER_TAG"
 
 
 # Start the build
-echo "Building docker image: $DOCKER_REPO_NAME:$DOCKER_TAG..."
+echo "Building docker image: $DOCKER_REPO_NAME:$DOCKER_BRANCH_TAG"
 
-docker build --no-cache -t $DOCKER_REPO_NAME:$DOCKER_TAG .
-echo "Creating tag 'latest'..."
-docker tag $DOCKER_REPO_NAME:$DOCKER_TAG $DOCKER_REPO_NAME:latest
+if [[ $DOCKER_REPO_NAME == *"functest"* ]]; then
+    docker build --no-cache -t $DOCKER_REPO_NAME:$DOCKER_BRANCH_TAG --build-arg BRANCH=$branch .
+else
+    docker build --no-cache -t $DOCKER_REPO_NAME:$DOCKER_BRANCH_TAG .
+fi
+
+echo "Creating tag '$DOCKER_TAG'..."
+docker tag $DOCKER_REPO_NAME:$DOCKER_BRANCH_TAG $DOCKER_REPO_NAME:$DOCKER_TAG
 
 # list the images
 echo "Available images are:"
@@ -102,8 +118,9 @@ if [[ "$PUSH_IMAGE" == "true" ]]; then
     echo "--------------------------------------------------------"
     echo
     # Push to the Dockerhub repository
-    docker push $DOCKER_REPO_NAME:$DOCKER_TAG
+    echo "Pushing $DOCKER_REPO_NAME:$DOCKER_BRANCH_TAG ..."
+    docker push $DOCKER_REPO_NAME:$DOCKER_BRANCH_TAG
 
-    echo "Updating $DOCKER_REPO_NAME:latest to the docker registry..."
-    docker push $DOCKER_REPO_NAME:latest
+    echo "Pushing $DOCKER_REPO_NAME:$DOCKER_TAG ..."
+    docker push $DOCKER_REPO_NAME:$DOCKER_TAG
 fi